﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Collections.Generic

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            ViewState("CurrentAlphabet") = "ALL"
            Me.GenerateAlphabets()
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("SELECT * FROM Customers WHERE ContactName LIKE @Alphabet + '%' OR @Alphabet = 'ALL'")
                Using sda As New SqlDataAdapter()
                    cmd.Connection = con
                    cmd.Parameters.AddWithValue("@Alphabet", ViewState("CurrentAlphabet"))
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        GridView1.DataSource = dt
                        GridView1.DataBind()
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Private Sub GenerateAlphabets()
        Dim alphabets As New List(Of ListItem)()
        Dim alphabet As New ListItem()
        alphabet.Value = "ALL"
        alphabet.Selected = alphabet.Value.Equals(ViewState("CurrentAlphabet"))
        alphabets.Add(alphabet)
        For i As Integer = 65 To 90
            alphabet = New ListItem()
            alphabet.Value = [Char].ConvertFromUtf32(i)
            alphabet.Selected = alphabet.Value.Equals(ViewState("CurrentAlphabet"))
            alphabets.Add(alphabet)
        Next
        rptAlphabets.DataSource = alphabets
        rptAlphabets.DataBind()
    End Sub


    Protected Sub OnPageIndexChanging(sender As Object, e As GridViewPageEventArgs)
        GridView1.PageIndex = e.NewPageIndex
        Me.BindGrid()
    End Sub

    Protected Sub Alphabet_Click(sender As Object, e As EventArgs)
        Dim lnkAlphabet As LinkButton = DirectCast(sender, LinkButton)
        ViewState("CurrentAlphabet") = lnkAlphabet.Text
        Me.GenerateAlphabets()
        GridView1.PageIndex = 0
        Me.BindGrid()
    End Sub
End Class

